import os
import sys
import pandas as pd

import spacy
from spacy.matcher import Matcher

sys.path.append(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
from lib.utils.Storage import Storage
from lib.utils.TextUtils import *


"""
Assumes pos ngrams generated by PosNgramsPipeline

"""
class WildMatcher:
    def __init__(self, text_path) -> None:
        self.storage = Storage()
        self.nlp = spacy.load("en_core_web_lg")
        self.doc = self.nlp(self.storage.read_file(text_path))


    def match_pos_ngrams(self, pos_ngram_csv_path): 
        matcher = Matcher(self.nlp.vocab)
        ignore_pos = ['SPACE', 'DET', 'PUNCT', 'PRON', 'AUX', 'CCONJ', 'PART', 'ADP']
        pos_ngram_df = self.storage.csv_to_df(pos_ngram_csv_path)
        for index, row in pos_ngram_df.iterrows():
            if not any(pos in row['str'] for pos in ignore_pos):
                # print('==== ->>', row['str'])
                pattern = []
                poss = row['str'].split(' ')
                for pos in poss:
                    pattern.append({'POS': pos})

                matcher.add(str(row['count']) + '-' + row['str'].replace(' ', '-'), [pattern])

        matches_arr = []
        matches = matcher(self.doc)
        for match_id, start, end in matches:
            string_id = self.nlp.vocab.strings[match_id]  # Get string representation
            span = self.doc[start:end]  # The matched span
            # print(string_id, span.text)
            count = string_id.split('-')[0]
            string_id = '-'.join(string_id.split('-')[1:])
            matches_arr.append([string_id, span.text, count, start, end])

        matches_df = pd.DataFrame(data=matches_arr, columns=['pos', 'match','count', 'start', 'end'])
        matches_df.to_csv(pos_ngram_csv_path.replace('.csv', '-matches.csv'))


    def match_tag_ngrams(self, tag_ngram_csv_path): 
        matcher = Matcher(self.nlp.vocab)
        ignore_tags = ['_SP', '.', ',', ':' 'CC', 'DT', 'IN']
        tag_ngram_df = self.storage.csv_to_df(tag_ngram_csv_path)
        for index, row in tag_ngram_df.iterrows():
            if not any(tag in row['str'] for tag in ignore_tags):
                # print('==== ->>', row['str'])
                pattern = []
                tags = row['str'].split(' ')
                for tag in tags:
                    pattern.append({'TAG': tag})

                matcher.add(str(row['count']) + '-' + row['str'].replace(' ', '-'), [pattern])

        matches_arr = []
        matches = matcher(self.doc)
        for match_id, start, end in matches:
            string_id = self.nlp.vocab.strings[match_id]  # Get string representation
            span = self.doc[start:end]  # The matched span
            # print(string_id, span.text)
            count = string_id.split('-')[0]
            string_id = '-'.join(string_id.split('-')[1:])
            matches_arr.append([string_id, span.text, count, start, end])

        matches_df = pd.DataFrame(data=matches_arr, columns=['tags', 'match','count', 'start', 'end'])
        matches_df.to_csv(tag_ngram_csv_path.replace('.csv', '-matches.csv'))


    def match_dep_ngrams(self,dep_ngram_csv_path):  
        matcher = Matcher(self.nlp.vocab)
        ignore_tags = ['dep', 'punct', 'det', 'prep', 'cc', 'advmod', 'poss', 'aux', 'quantmod']
        tag_ngram_df = self.storage.csv_to_df(dep_ngram_csv_path)
        for index, row in tag_ngram_df.iterrows():
            if not any(tag in row['str'] for tag in ignore_tags):
                # print('==== ->>', row['str'])
                pattern = []
                tags = row['str'].split(' ')
                for tag in tags:
                    pattern.append({'DEP': tag})

                # matcher.add(row['str'].replace(' ', '-'), [pattern])
                matcher.add(str(row['count']) + '-' + row['str'].replace(' ', '-'), [pattern])

        matches_arr = []
        matches = matcher(self.doc)
        for match_id, start, end in matches:
            string_id = self.nlp.vocab.strings[match_id]  # Get string representation
            span = self.doc[start:end]  # The matched span
            # print(string_id, span.text)
            count = string_id.split('-')[0]
            string_id = '-'.join(string_id.split('-')[1:])
            matches_arr.append([string_id, span.text, count, start, end])

        matches_df = pd.DataFrame(data=matches_arr, columns=['deps', 'match','count', 'start', 'end'])
        matches_df.to_csv(dep_ngram_csv_path.replace('.csv', '-matches.csv'))


if __name__ == '__main__':
    wildMatcher = WildMatcher('/home/michael/topics/make-money-online/www_hostinger_com_tutorials_make_money_online/text/text.txt')
    for i in range(1,7):
        wildMatcher.match_pos_ngrams('/home/michael/topics/make-money-online/www_hostinger_com_tutorials_make_money_online/text/pos/pos-ngram-' + str(i) + '.csv')
        wildMatcher.match_tag_ngrams('/home/michael/topics/make-money-online/www_hostinger_com_tutorials_make_money_online/text/pos/tag-ngram-' + str(i) + '.csv')
        wildMatcher.match_dep_ngrams('/home/michael/topics/make-money-online/www_hostinger_com_tutorials_make_money_online/text/pos/dep-ngram-' + str(i) + '.csv')